// SampleGrabber.h: interface for the CSampleGrabber class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SAMPLEGRABBER_H__4EB6E25B_9885_4A4A_9352_3A00DA4CBD1C__INCLUDED_)
#define AFX_SAMPLEGRABBER_H__4EB6E25B_9885_4A4A_9352_3A00DA4CBD1C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSampleGrabber : public ISampleGrabberCB
{
public:

	CSampleGrabber();

	virtual ~CSampleGrabber();

public:

	STDMETHODIMP			  QueryInterface( REFIID riid, void ** ppv ) { if( (riid == IID_ISampleGrabberCB) || (riid == IID_IUnknown) ) { *ppv = (void *)(static_cast<ISampleGrabberCB *>(this)); return NOERROR; } return E_NOINTERFACE; }

	STDMETHODIMP_(ULONG)	  AddRef() { return 2; };

	STDMETHODIMP_(ULONG)	  Release() { return 1; };

	// DEBUGGING FUNCTIONS
	//
	VOID					  SC_DEBUG( CHAR * fmt, ... );

	// MEMBER FUNCTIONS
	// 
	STDMETHODIMP			  BufferCB( double dSampleTime, BYTE * pBuffer, LONG nBufferLen ); // { return E_NOTIMPL; }

	STDMETHODIMP			  SampleCB( double dSampleTime, IMediaSample * pSample ); // { return E_NOTIMPL; }

	PF_BUFFER_CALLBACK		  GetCallback() { return m_pBufferCB; }

	BOOL					  SetCallback( PF_BUFFER_CALLBACK pBufferCB, PVOID pUserData ) { m_pBufferCB = pBufferCB; m_pUserData = pUserData; return TRUE; }

	// MEMBER VARIABLES
	// 
	PF_BUFFER_CALLBACK		  m_pBufferCB;
	
	PVOID					  m_pUserData;
};

#endif // !defined(AFX_SAMPLEGRABBER_H__4EB6E25B_9885_4A4A_9352_3A00DA4CBD1C__INCLUDED_)
