// AnalogDeviceVideoGraph.h: interface for the CAnalogDeviceVideoGraph class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ANALOGDEVICEVIDEOGRAPH_H__AE76E803_E285_4895_B23A_D1E837862578__INCLUDED_)
#define AFX_ANALOGDEVICEVIDEOGRAPH_H__AE76E803_E285_4895_B23A_D1E837862578__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Graph.h"

class CAnalogDeviceVideoGraph : public CGraph  
{
public:

	CAnalogDeviceVideoGraph();

	virtual ~CAnalogDeviceVideoGraph();

public:

	// DEBUGGING FUNCTIONS
	//
	VOID					  SC_DEBUG( CHAR * fmt, ... );

	// MEMBER FUNCTIONS
	//
	BOOL					  Close( BOOL bDumpDebugMessage = TRUE );

	BOOL					  Create( PWSTR pwszDevName, UINT iDevNum, PF_BUFFER_CALLBACK pBufferCBs[ 4 ], PVOID pUserDatas[ 4 ] );

	BOOL					  GetFormat( ULONG * pColorSpaceType, ULONG * pWidth, ULONG * pHeight, ULONG * pBitCount, double * pFrameRate );

	BOOL					  SetFormat( ULONG nColorSpaceType, ULONG nWidth, ULONG nHeight, ULONG nBitCount, double dFrameRate );

	BOOL					  GetStandard( ULONG * pStandard );

	BOOL					  SetStandard( ULONG nStandard );

	BOOL					  GetLock( ULONG * pLock );

	BOOL					  GetVideoProcAmpProperty( ULONG nSubChannelNumber, ULONG nProperty, ULONG * pValue );

	BOOL					  SetVideoProcAmpProperty( ULONG nSubChannelNumber, ULONG nProperty, ULONG nValue );

	BOOL					  GetCustomPropertyEx( ULONG nProperty, BYTE * pValue, ULONG nBytes );

	BOOL					  SetCustomPropertyEx( ULONG nProperty, BYTE * pValue, ULONG nBytes );
	
	BOOL					  GetCustomProperty( ULONG nProperty, ULONG * pValue );
	
	BOOL					  SetCustomProperty( ULONG nProperty, ULONG nValue );

	// MEMBER VARIABLES
	// 
	IBaseFilter *             m_pCaptureSourceBaseFilter;

	IBaseFilter *             m_pSplitTeeBaseFilter;

	IBaseFilter *             m_pSampleGrabberBaseFilters[ 4 ];

	IKsPropertySet *          m_pKsPropertySet;

	GUID					  m_sKsPropertySetGUID;

	IAMAnalogVideoDecoder *   m_pAMAnalogVideoDecoder;

	IAMStreamConfig *		  m_pAMStreamConfig;

	IAMVideoProcAmp *		  m_pAMVideoProcAmp;

	IAMCrossbar *			  m_pAMCrossbar;

	CSampleGrabber			  m_oSampleGrabbers[ 4 ];
	
	ISampleGrabber * 		  m_pSampleGrabbers[ 4 ];

	ULONG					  m_nColorSpaceType;

	ULONG					  m_nWidth;

	ULONG					  m_nHeight;

	ULONG					  m_nBitCount;

	double					  m_dFrameRate;
};

#endif // !defined(AFX_ANALOGDEVICEVIDEOGRAPH_H__AE76E803_E285_4895_B23A_D1E837862578__INCLUDED_)
