// StreamCatcherDemoDlg.h : header file
//

#if !defined(AFX_STREAMCATCHERDEMODLG_H__DF394323_15B8_4E17_AA4E_BFC507BE5EE2__INCLUDED_)
#define AFX_STREAMCATCHERDEMODLG_H__DF394323_15B8_4E17_AA4E_BFC507BE5EE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChannelWindow.h"

#include "SetupDlg.h"

/////////////////////////////////////////////////////////////////////////////
// sc580Dlg dialog

class sc580Dlg : public CDialog
{
// Construction
public:
	sc580Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(sc580Dlg)
	enum { IDD = IDD_STREAMCATCHERDEMO_DIALOG };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(sc580Dlg)
	protected:
	virtual void OnOK();
	virtual void OnCancel();
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(sc580Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:

	// STATIC CLASS VARIABLE
	//
	static sc580Dlg*	s_psc500Dlg;

	static CRect		s_rect_slipts_display[ 4 ];

	static CRect		s_rect_slipts_display_clone[ 4 ];

	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	CRect				GetSplitWndPos_sc500Dlg( ULONG nChannelNumber, ULONG nGridDivisions, ULONG nRendererWidth, ULONG nRendererHeight );

	BOOL				OnLButtonDblClk_ChannelWindow( ULONG nChannelNum, UINT nFlags, CPoint point );

	BOOL				OnButtonFileRecording_FileRecordDialog();

	BOOL				OnButtonShareRecording_FileRecordDialog();
	
	BOOL				OnButtonVideoInput_SetupDialog();

	BOOL				OnButtonAudioInput_SetupDialog();

	BOOL				OnButtonVideoQuality_SetupDialog();

	BOOL				OnButtonSnapshotJPG_SetupDialog();

	BOOL				OnButtonSnapshotBMP_SetupDialog();

	BOOL				OnCheckGpuSupport_SetupDialog();

	BOOL				OnCheckAutoDeinterlace_SetupDialog();

	BOOL				OnCheckShowCloneVideo_SetupDialog();	

	BOOL				HwUninitialize();

	BOOL				HwInitialize();
	
	////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	CChannelWindow		m_oChannelWindows_LIVE[ 4 ];

	CChannelWindow		m_oChannelWindows_BK[ 4 ];

	CChannelWindow		m_oCloneWindows[ 4 ];
	
	CSetupDlg			m_oSetupDialog;
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// VIDEO PROPERTIES
	
	PVOID 				m_hVideoDevice[ 4 ];

	PVOID				m_hCloneCapDev[ 4 ];

	ULONG				m_nVideoWidth[ 4 ];

	ULONG				m_nVideoHeight[ 4 ];

	BOOL				m_bVideoIsInterleaved[ 4 ];

	ULONG				m_nVideoFrameRate[ 4 ];
	
	BOOL				m_bNoSignal[ 4 ];

	BOOL				m_bVideoDeinterlaceEnable;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 

	//BOOL				m_bIsRecord[ 4 ];

	//BOOL				m_bSupportGPU[ 4 ];

	BOOL				m_bShareSupportGPU1_1;

	BOOL				m_bIsShareRecord;

	BOOL				m_bShareRecordCH[ 4 ];

	BOOL				m_bSupportGPU1_1;
	
	BOOL				m_bIsRecord1_1;

	BOOL				m_bSupportGPU1_2;
	
	BOOL				m_bIsRecord1_2;
	
	BOOL				m_bSupportGPU2_1;
	
	BOOL				m_bIsRecord2_1;

	BOOL				m_bSupportGPU2_2;
	
	BOOL				m_bIsRecord2_2;

	BOOL				m_bSupportGPU3_1;
	
	BOOL				m_bIsRecord3_1;

	BOOL				m_bSupportGPU3_2;
	
	BOOL				m_bIsRecord3_2;

	BOOL				m_bSupportGPU4_1;
	
	BOOL				m_bIsRecord4_1;

	BOOL				m_bSupportGPU4_2;
	
	BOOL				m_bIsRecord4_2;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// AUDIO PROPERTIES

	ULONG				m_nAudioChannels[ 4 ];

	ULONG				m_nAudioBitsPerSample[ 4 ];

	ULONG				m_nAudioSampleFrequency[ 4 ];

	ULONG				m_nCurSelectChannelNumber;

	ULONG				m_nAudioPlayChannel;

	BOOL				m_nWndState;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// QUALITY PROPERTIES
	
	ULONG				m_nSharpness[ 4 ];

	ULONG				m_nSaturation[ 4 ];

	ULONG				m_nHue[ 4 ];

	ULONG				m_nConstrast[ 4 ];

	ULONG				m_nBrightness[ 4 ];

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// RECORD & FILE PROPERTIES
	
	CString				m_strDefaultPath;

	CString				m_strSnapshotPath;

	CString				m_strRecordPath;

	CString				m_strRecordFileName;

	CString				m_strFormatChangedOutput[ 4 ];
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STREAMCATCHERDEMODLG_H__DF394323_15B8_4E17_AA4E_BFC507BE5EE2__INCLUDED_)
